"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Actions(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "actionType",
        "source",
        "tumorType",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "actionType": reports_2_1_0.ActionType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "Gel_BioInf_Models.ActionType": reports_2_1_0.ActionType,
            "Gel_BioInf_Models.Actions": reports_2_1_0.Actions,
        }

    __slots__ = [
        "actionType",
        "source",
        "tumorType",
        "comments",
        "drug",
        "evidence",
        "evidenceType",
        "status",
    ]

    def __init__(
        self,
        actionType,
        source,
        tumorType,
        comments=None,
        drug=None,
        evidence=None,
        evidenceType=None,
        status=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_2_1_0.Actions model.

        :param actionType:
        :type actionType: ActionType
        :param source:
            source of the information
        :type source: str
        :param tumorType:
            This is the tumor type considered to act on this variant
        :type tumorType: str
        :param comments:
            comments
        :type comments: None | list[str]
        :param drug:
            drug
        :type drug: None | str
        :param evidence:
            array of PMIDs
        :type evidence: None | list[str]
        :param evidenceType:
            type of evidence
        :type evidenceType: None | str
        :param status:
            status i.e. clinical, pre-clinical
        :type status: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.1.0"
